package v1alpha1

import (
	"fmt"

	metav1 "k8s.io/apimachinery/pkg/apis/meta/v1"
)

const MailSecretSuffix = "mail.libre.sh"

// MailSpec defines the desired state of Mail
type MailSpec struct {
	//+optional
	Suspend bool `json:"suspend,omitempty"`
	//+required
	Address string `json:"address"`
}

// MailStatus defines the observewd state of Mail
type MailStatus struct {
	// INSERT ADDITIONAL STATUS FIELD - define observed state of cluster
	// Important: Run "make" to regenerate code after modifying this file
}

//+kubebuilder:object:root=true
//+kubebuilder:subresource:status

// Mail is the Schema for the mails API
type Mail struct {
	metav1.TypeMeta   `json:",inline"`
	metav1.ObjectMeta `json:"metadata,omitempty"`

	Spec   MailSpec   `json:"spec,omitempty"`
	Status MailStatus `json:"status,omitempty"`
}

//+kubebuilder:object:root=true

// MailList contains a list of Mail
type MailList struct {
	metav1.TypeMeta `json:",inline"`
	metav1.ListMeta `json:"metadata,omitempty"`
	Items           []Mail `json:"items"`
}

func init() {
	SchemeBuilder.Register(&Mail{}, &MailList{})
}

func (mail *Mail) GetSecretName() string {
	return fmt.Sprintf("%s.%s", mail.Name, MailSecretSuffix)
}
